/*
* Copyright c                  Realtek Semiconductor Corporation, 2003
* All rights reserved.
* 
* Program : Header file for  fowrading engine rtl8651_tblDrvFwd.c
* Abstract : 
* Author :  Chun-Feng Liu(cfliu@realtek.com.tw)
* $Id: rtl8651_tblDrvFwd.h,v 1.47 2004/07/23 13:19:57 tony Exp $
* $Log: rtl8651_tblDrvFwd.h,v $
* Revision 1.47  2004/07/23 13:19:57  tony
* *: remove all warning messages.
*
* Revision 1.46  2004/07/19 12:54:43  chenyl
* *: bug fix: process udp packets withc zero-checksum
* *: bug fix: process L3/L4 packets whose ip-header length is not 20 byte
* +: add testing functions to compare/clear checksum field of mbuf/pkthdr
*
* Revision 1.45  2004/07/13 02:53:16  tony
* *: fix protostack packets be drop in pptp/l2tp mode.
*
* Revision 1.44  2004/07/12 04:25:36  chenyl
* *: extend existing port scan mechanism
*
* Revision 1.43  2004/07/09 05:20:17  cfliu
* +: Redefine FWDENG_XXXX type code
*
* Revision 1.42  2004/07/08 14:35:09  cfliu
* +: Add new param mbufheadroom in fwd init data structure
*
* Revision 1.41  2004/07/05 11:32:47  chenyl
* +: dynamically turn-ON/OFF port bouncing
*
* Revision 1.40  2004/07/04 15:04:29  cfliu
* +:put protocol stack send function from L2 to L3/4 fwd engine
*
* Revision 1.39  2004/06/30 03:16:49  chenyl
* *: bug fix of Multicast Filter
* *: remove one unused parameter in multicast system
*
* Revision 1.38  2004/06/29 07:34:23  chenyl
* +: IGMPv3
* +: igmp proxy filter :
* 		protocol stack can let igmp-proxy
* 			1: trap specific multicast group
* 			2: ignore specific multicast group
*
* Revision 1.37  2004/06/29 07:31:12  cfliu
* +:Add a switch to turn on/off WAN->WAN routing
*
* Revision 1.36  2004/06/18 08:11:15  tony
* +: add new features: SYN,FIN,ACK Port Scan.
*
* Revision 1.35  2004/06/14 07:32:44  yjlou
* *: fixed the bug of setting protocol-based VLAN for PPPoE when disabled in boot time.
* *: move rtl8651_drvProtocolBasedNatEnable from 'rtl8651_tblDrvFwd.c' to 'rtl8651_tblDrv.c'.
* *: move rtl8651_drvPppoePassthruEnable and rtl8651_drvIpv6PassthruEnable from 'rtl8651_tblDrvFwd.c' to 'rtl8651_layer2.c'.
*
* Revision 1.34  2004/06/08 14:17:51  jzchen
* +: Define enable/disable pppoe session ID not exist termination feature API
* +: Define active PPPoE session ID tracking data structure
* +: Define active PPPoE session ID tracking number in forwarding engine initial parameter
*
* Revision 1.33  2004/06/07 13:05:49  yjlou
* +: Supporting IPv6 Passthru
* *: By default, Protocol-Based NAT, PPPoE Passthru, and IPv6 Passthru is disabled.
* *: PPPoE Passthru and IPv6 Passthru share the same VLAN
* *: The code changing VLAN ID is moved to forwording engine.
*
* Revision 1.32  2004/06/01 09:36:27  chhuang
* add a new type: FWDENG_ACL_DROP_NOTIFY
*
* Revision 1.31  2004/05/20 12:28:35  chenyl
* *: for fast path packets, only check SYN/FIN/UDP/ICMP flooding DOS
* *: fast path packets don't run Egress ACL
* *: BUG FIX: refresh age-time of UDP flows in forwarding engine
*
* Revision 1.30  2004/05/20 06:41:33  chenyl
* *: fragment system : if (DOS)/(UDP blocking) is disabled, don't queue in-the-order packets
* *: check all dos attacks for each packet
* *: bug fix in port bouncing
* *: apply TCP state tracking in port bouncing
* *: bug fix in multicast system
*
* Revision 1.29  2004/05/19 16:09:57  yjlou
* +: add rtl8651_EnablePppoePassthru() to enable/disable PPPoE passthru.
*
* Revision 1.28  2004/05/19 14:01:26  yjlou
* +: support Protocol-Based NAT
*
* Revision 1.27  2004/05/17 12:13:19  cfliu
* no message
*
* Revision 1.26  2004/05/12 07:20:15  chenyl
* +: source ip blocking
* *: modify dos mechanism
*
* Revision 1.25  2004/05/06 08:03:35  chhuang
* add MAC filtering
*
* Revision 1.24  2004/05/05 09:00:03  chhuang
* add MAC filter
*
* Revision 1.23  2004/05/05 08:27:07  tony
* new features: add remote management spec
*
* Revision 1.22  2004/05/05 04:28:50  chenyl
* +: arp proxy
* *: bug fix (L2TP/PPTP) in layer2fwd.c
*
* Revision 1.21  2004/05/04 12:46:27  chenyl
* *: modify ipQueue/multicast system
*         +:  ipQueue:   can constraint total queued packet only
*         +:  multicast: can constraint total member only
*         *:  allocate table when ipQueue/Multicast init()
*         *:  if table size == 0 , ipQueue/Multicast system become disable
*         *:  switch to turn on/off Multicast system dynamically
*
* *: add CLE command to turn on/off ipQueue/ Multicast system
*
* *: change the init method: init ipQueue/multicast system in rtl8651_fwdEngineInit(configPara)
*    and set initial value using "configPara"
*
* Revision 1.20  2004/05/03 14:54:17  cfliu
* Add 8650B extension port support.
* Revise all WLAN/extport related code.
*
* Revision 1.19  2004/04/30 08:58:08  chenyl
* +: ip multicast/igmp proxy
*
* Revision 1.18  2004/04/21 08:44:43  tony
* PPTP/L2TP support remote management for CyberTAN spec.
*
* Revision 1.17  2004/04/14 08:43:56  tony
* make L2TP support auto reconnect.
*
* Revision 1.16  2004/04/08 13:18:12  tony
* add PPTP/L2TP routine for MII lookback port.
*
* Revision 1.15  2004/04/08 12:12:53  cfliu
* Add WDS support on extension port API
*
* Revision 1.14  2004/04/07 11:29:33  chenyl
* *: bug fix in fwd-engine : remove "isToEthBcast"
* +: rtl8651_fwdEngineProcessIPFragment(enable) to enable/disable ipQueue system
* 	enable : fragment packets are processed by fwdeng
* 	disable: fragment packets are trapped to protocol stack
*
* Revision 1.13  2004/04/06 01:50:32  chenyl
* *: for pkts generated/queued in fwdeng, free MbufChain and return SUCCESS when fwdengSend Fail
*
* Revision 1.12  2004/03/31 09:36:23  cfliu
* Add WDS support
*
* Revision 1.11  2004/03/24 09:46:44  chenyl
* +: queued packet to CPU
*
* Revision 1.10  2004/03/22 12:29:53  chenyl
* +: _RTL_QUEUE_FRAG_PKT for fragment packet Queue system
*
* Revision 1.9  2004/03/19 13:13:35  cfliu
* Reorganize ROME driver local header files. Put all private data structures into different .h file corrsponding to its layering
* Rename printf, printk, malloc, free with rtlglue_XXX prefix
*
* Revision 1.8  2004/03/18 07:24:42  chenyl
* +: port bouncing for DMZ Host / NAT
*
* Revision 1.7  2004/03/16 15:10:53  chenyl
* +: support IP-unnumbered -> DMZ Host port bouncing
*
* Revision 1.6  2004/03/12 08:18:18  chenyl
* *: add rtl8651_fwdEngineIcmpRoutingMsg()
*
* Revision 1.5  2004/03/12 01:39:33  chenyl
* * Rename
* 	rtl8651_IcmpToDMZHostEnable -> rtl8651_DMZHostIcmpPassthroughEnable
* 	rtl8651_fwdEngineIcmpToDMZHost -> rtl8651_fwdEngineDMZHostIcmpPassThrough
*
* * Bug Fix
* 	in FwdengineSend()
* 		remove:
* 			retval &=~FWDENG_DROP;
*                		mBuf_driverFreeMbufChain(mbuf);
*
* 	_rtl8651_drvIcmpAgent()
* 		rewrite
*
* 	l4TcpNaptAliasIn
* 		fix key-in bug
* * Add Features
* 	_rtl8651_drvIcmpErrorGeneration
* 		FwdEngine will be able to reply ICMP TIME EXCEED Message
*
* * Some counter name is changed
*
* Revision 1.4  2004/03/11 04:08:57  cfliu
* fix layer2*.c compile problems
*
* Revision 1.3  2004/03/03 03:20:52  chenyl
* *: Policy route by SIP
* *: modify _rtl8651_drvIcmp, bounce packet back to ingress interface
* +: FwdEngineReinit() for reset fwdeng's variable and data structures
*
* Revision 1.2  2004/02/27 13:37:17  chenyl
* +: napt-icmp path for
* 	+: outbound TSTAMP
* 	+: outbound ERROR Message
* 	+: outbound TSTAMPREPLY/ECHOREPLY
* 	+: inbound TSTAMP/ECHO forwarding to dmzhost
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.4  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.31  2004/02/24 04:24:48  cfliu
* Remove WLAN pure bridging variables.
* Remove some FWDENG error number due to change in fwd engine
*
* Revision 1.30  2004/02/12 06:58:39  tony
* add those define in this header file
* rtl8651_flushProtoStackUsedUdpPorts(),rtl8651_flushProtoStackServerUsedTcpPorts()
* rtl8651_addProtoStackUsedUdpPort(),rtl8651_addProtoStackServerUsedTcpPort()
*
* Revision 1.29  2004/02/12 06:25:17  rupert
* Rename pppoeId to SessionID
* Fixed  rtl8651_flushPolicyRoute about dynamic route
*
* Revision 1.28  2004/02/09 02:49:58  tony
* enable Port Bouncing routine.
*
* Revision 1.27  2004/02/06 12:33:37  tony
* add rtl8651a_addTriggerPortRule and rtl8651a_flushTriggerPortRules API
*
* Revision 1.26  2004/02/06 07:23:47  rupert
* Add rtl8651a_setUdpSizeThreshValue prototype
*
* Revision 1.25  2004/02/05 12:11:52  tony
* add Port Bouncing Routine(support port change).
* (please define _RTL_PORT_BOUNCING in FwdEng header file to turn it on)
*
* Revision 1.24  2004/01/30 12:03:05  tony
* make Special Application is able to support multiple session.
*
* Revision 1.23  2004/01/15 13:41:49  tony
* modify UPNP_ITEM from 64 to 96.
*
* Revision 1.22  2004/01/13 12:51:21  hiwu
* remove PPTP WAN port type support (because bug)
*
* Revision 1.21  2004/01/09 09:30:35  hiwu
* add PPTP WAN type support
*
* Revision 1.20  2004/01/07 06:49:19  hiwu
* FIX VPN passthrough support
*
* Revision 1.19  2003/12/31 04:59:26  tony
* fix bug: turn L2TP ALG on/off dynamically.
*
* Revision 1.18  2003/12/26 10:54:22  hiwu
* merge RTL865x_Bridge back
*
* Revision 1.17  2003/12/17 10:24:56  hiwu
* add checksum function
*
* Revision 1.16  2003/12/16 12:09:41  tony
* disable debug message
*
* Revision 1.15  2003/12/16 12:07:22  tony
* fix bug: make DirectX ALG support game AOE2.
*
* Revision 1.14  2003/12/09 15:25:25  cfliu
* MUST add linux/config.h....
*
* Revision 1.13  2003/12/09 12:05:45  hiwu
* add RTL865x_Bridge
*
* Revision 1.12  2003/11/07 05:34:36  tony
* modify YMSG ALG, it'll not have to cooperate with trigger port.
*
* Revision 1.11  2003/10/23 07:10:18  hiwu
* add pptp alg support
*
* Revision 1.10  2003/10/17 04:33:12  hiwu
* add new DOS callback function
*
* Revision 1.9  2003/10/15 08:04:47  tony
* move Trigger Port range checking routine from FastAlias to NaptAlias
*
* Revision 1.8  2003/10/09 13:23:44  tony
* TRIGGER_PORT: add function rtl8651_flushTriggerPortRules,rtl8651_addTriggerPortRule
*
* Revision 1.7  2003/10/06 05:54:19  orlando
* check in final-round table driver merging result
*
* Revision 1.9  2003/10/04 14:59:02  cfliu
* remove some FWDENG_XXX types and change rtl8651_fwdEngineSend function prototype
*
* Revision 1.8  2003/10/03 16:48:30  cfliu
* no message
*
* Revision 1.7  2003/09/26 09:34:46  cfliu
* no message
*
* Revision 1.6  2003/09/24 12:21:15  cfliu
* add url filter reason
*
* Revision 1.5  2003/09/23 05:42:11  cfliu
* no message
*
* Revision 1.4  2003/09/20 10:43:49  cfliu
* no message
*
* Revision 1.3  2003/09/19 05:03:02  cfliu
* Add new fwd engine error code
* Add _rtl8651_fwdEngineScanDoS()
* rename _rtl8651_l4AddAlgLink as _rtl8651_fwdEngineRegisterAlgModule and change its prototype.
*
*/
#ifndef RTL8651_FWDENGINE_H
#define RTL8651_FWDENGINE_H


#define _RTL_IP_FRAG 		/* enable ip fragmenet */
#define _RTL_NAPT_FRAG 		/* enable napt ip fragment process */
#define _RTL_NAPT_SHORT_CUT   /*enable napt short cut forward */
#define _RTL_DMZ 			/* enable Realtek define DMZ */
#define _RTL_BRIDGE 	 		/* enable Realtek's software bridge */
#define _RTL_UPNP 			/* enable Realtek's software UPNP IDG support */
#define _RTL_QUEUE_ARP_PACKET		/* enable Realtek's arp queue packet support */
#define _RTL_TRIGGER_PORT	/* enable Realtek's software Trigger Port support */
#define _RTL_DOS_PLUGIN		/* enable Realtek's software DOS plugin function */
#define _RTL_PORT_BOUNCING		/* enable Realtek's software DOS plugin function */
#define _RTL_PS_ACTION /* enable Realtek's Protocol Stack Action function */

#ifdef _RTL_IP_FRAG
#define _RTL_QUEUE_FRAG_PKT	/* enable Realtek's fragment packet queue support */
#endif /* _RTL_IP_FRAG */

//#define _TONY_DEBUG // just for testing


#include "assert.h"
#include "types.h"
#ifndef CYGWIN
#include <linux/config.h>
#endif /* CYGWIN */
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_ipQueue.h"
#include "rtl8651_multicast.h"

/////////////////////////////////////////////////////////
//// Error codes
/////////////////////////////////////////////////////////

#define FWDENG_DROP		0x1000

/* ACL related */
#define FWDENG_ACL_DROP_NOTIFY		1 	//pkt dropped and a ICMP unreachable mesg sent to sender
#define FWDENG_ACL_IN_USERTRAP		2	//ingress pkt trapped to protocol stack
#define FWDENG_ACL_IN_DROP			3	//Pkt dropped by ingress ACL
#define FWDENG_ACL_OUT_USERTRAP		4	//egress pkt trapped to protocol stack
#define FWDENG_ACL_OUT_DROP			5	//Pkt dropped by egress ACL

/* L2 related */
#define FWDENG_BROADCAST			10	//L2 broadcast, send to protocol stack
#define FWDENG_VLANINVALID			11	//Invalid VLAN. Maybe not yet configured.
#define FWDENG_VLANCFI				12	//Vlan tagged pkt with CFI=1
#define FWDENG_PPPOE8863			13	//PPPoE discovery phase pkt
#define FWDENG_PPPOE8864			14	//PPPoE session phase pkt
#define FWDENG_ARP_NOTREQ			15	//Not a ARP request
#define FWDENG_ARP_OTHERS			16	//ARP request to other host
#define FWDENG_ARP_REQUEST			17	//ARP request, Let protocol stack send reply.
#define FWDENG_NOTIPPACKET			18	//destined to gateway, but not IP packet.
#define FWDENG_MACBLOCK				19


/* L3 - Non-IP */
#define FWDENG_NETIFACENOTFOUND		20	//No layer3 network interface attached on receiving VLAN
#define FWDENG_L34DISABLED			21	//Layer3/4 operation is disabled. All such pkts goes to protocol stack.
#define FWDENG_IGMPPKT				22	//IGMP pkt not processed. Send to protocol stack
#define FWDENG_GRE_IGNORE			23
#define FWDENG_ESP_IGNORE			24
#define FWDENG_L3UNKNOWNPROTO		25	//unknown L3 protocol

/* IP */
#define FWDENG_IP_CANTFRAG			30	//Can't handle IP fragment			
#define FWDENG_IP_WAN2WAN_ROUTING	31	//pkt rcvd from WAN and should be routed to WAN but function disabled by user
#define FWDENG_IP_CANTQUEUEFRAGMENT	32	//Out of fragment queue space
#define FWDENG_IP_BADCKSUM			33	//IP cksum error
#define FWDENG_IP_TTLEXCEED			34	//TTL<2 and TTL-1 is required for routing
#define FWDENG_IP_INVALID			35	//invalid  IP in IP header
#define FWDENG_IP_MULTICAST			36	//IP multicast pkt.(not IGMP)

/* L4 - misc */
#define FWDENG_L4_UNKNOWNPROTO		40	//unsupported L4 protocol
#define FWDENG_L4_NAPT_UNSUPPORTPROTO	41  //must do NAPT but protocol is not TCP/UDP/ICMP
#define FWDENG_L4_INVALIDPORT		42  //Src or dst Port number is 0
#define FWDENG_L4_NATNOENTRY		43	//No matched entry in NAT table
#define FWDENG_L4_PORTBOUNCING		44  //pkt rcvd from LAN destined to local server's public IP but function disabled.

/* ICMP */
#define FWDENG_ICMP_OUT_ADDFAIL		50	//out of ICMP entry space
#define FWDENG_ICMP_OUT_INVALIDIPID	51	//invalid ICMP ip or id
#define FWDENG_ICMP_OUT_ERRFLOWNOTFOUND 52
#define FWDENG_ICMP_IN_ADDFAIL		53  //can't add inbound ICMP echo req to DMZ host
#define FWDENG_ICMP_IN_NOTFOUND  		54	//inbound icmp flow not found
#define FWDENG_ICMP_IN_ERRFLOWNOTFOUND	55	// flow not found in inbound ICMP error mesg
#define FWDENG_ICMP_BADCKSUM		56	//bad icmp checksum
#define FWDENG_ICMP_UNSUPPORTED		57

/* UDP */
#define FWDENG_UDP_BADCKSUM			60	//bad udp cksum
#define FWDENG_UDP_ECHOCHARGENBOMB	61	//suspicous UDP echo/chargen bomb pkt.
#define FWDENG_UDP_NAPT_OUT_NOTFOUND	62	//Failed to find specified UDP flow in NAPT table
#define FWDENG_UDP_NAPT_OUT_NOPORT	63	//All usable port numbers exhausted.
#define FWDENG_UDP_NAPT_OUT_ADDFAIL	64	//Failed to add new UDP napt entry. Table full?
#define FWDENG_UDP_NAPT_OUT_SVRALGADDFAIL	65 //Failed to add new UDP server alg napt entry. Table full?
#define FWDENG_UDP_NAPT_OUT_CLIALGADDFAIL	66 //Failed to add new UDP client alg napt entry. Table full?
#define FWDENG_UDP_NAPT_OUT_IGNORE			67
#define FWDENG_UDP_NAPT_IN_NOTFOUND			68
#define FWDENG_UDP_NAPT_IN_ALGADDFAIL		69
#define FWDENG_UDP_NAPT_IN_ADDFAIL			70
#define FWDENG_UDP_NAPT_IN_SERVERPORTNOTFOUND 71
#define FWDENG_UDP_NAPT_IN_IGNORE			72
#define FWDENG_UDP_NAT_IN_CLIALGADDFAIL 	73
#define FWDENG_UDP_NAT_IN_SVRALGADDFAIL 	74
#define FWDENG_UDP_NAT_IN_ALGNOTFOUND		75
#define FWDENG_UDP_NAT_IN_ALGIGNORE			76
#define FWDENG_UDP_NAT_OUT_ALGIGNORE		77
#define FWDENG_UDP_NAT_OUT_ALGNOTFOUND		78
#define FWDENG_UDP_NAT_OUT_CLIALGADDFAIL	79
#define FWDENG_UDP_NAT_OUT_SVRALGADDFAIL	80

/* TCP */
#define FWDENG_TCP_BADCKSUM					90
#define FWDENG_TCP_URLFILTERED				91
#define FWDENG_TCP_NAPT_OUT_CLIALGADDFAIL 	92	//adding a existing ALG control flow or ALG list full
#define FWDENG_TCP_NAPT_OUT_SVRALGADDFAIL 	93	//adding a existing ALG control flow or ALG list full
#define FWDENG_TCP_NAPT_OUT_ALGNOTFOUND		94
#define FWDENG_TCP_NAPT_OUT_NOIPPORT		95
#define FWDENG_TCP_NAPT_OUT_NOTFOUND		96
#define FWDENG_TCP_NAPT_OUT_ADDFAIL			97
#define FWDENG_TCP_NAPT_OUT_IGNORE			98
#define FWDENG_TCP_NAPT_IN_CLIALGADDFAIL	99
#define FWDENG_TCP_NAPT_IN_IGNORE			100
#define FWDENG_TCP_NAPT_IN_SVRALGADDFAIL	101
#define FWDENG_TCP_NAPT_IN_NOTFOUND			102
#define FWDENG_TCP_NAPT_IN_ADDFAIL			103
#define FWDENG_TCP_NAT_IN_ALGNOTFOUND		104
#define FWDENG_TCP_NAT_IN_ALGADDFAIL		105
#define FWDENG_TCP_NAT_IN_ALGIGNORE			106
#define FWDENG_TCP_NAT_OUT_ALGNOTFOUND		107
#define FWDENG_TCP_NAT_OUT_ALGIGNORE		108
#define FWDENG_TCP_NAT_OUT_ADDFAIL			109
#define FWDENG_TCP_NAT_OUT_ENTRYUPDATE		110

/* misc*/
#define FWDENG_USER_IDSCHECKDROP			120
#define FWDENG_USER_DROP					121
#define FWDENG_TO_GW						122	// packet must be trapped to gateway
#define FWDENG_QUEUED						123
#define FWDENG_QUEUED_TO_GW					124
#define FWDENG_NOTXPORT						125

#define FWDENG_TOTALERRS					126


struct rtl8651_fwdEngineInitPara_s;
int32 rtl8651_fwdEngineInit(struct rtl8651_fwdEngineInitPara_s *);
int32 rtl8651_fwdEngineReinit(void);
typedef int32 (*user_ids_chkFunc)(struct rtl_pktHdr *);
int32 rtl8651_fwdEngineRegUserIDScheckFunc(user_ids_chkFunc func);
int32 rtl8651_fwdEngineDropPktCase(uint32 fwdengDropCase, int32 *flag);
int32 rtl8651_fwdEngineSend(void * pkthdr, int16 dvid, int32 iphdrOffset);
int32 rtl8651_fwdEngineArp(int8 enable);
int32 rtl8651_fwdEngineIcmp(int8 enable);
int32 rtl8651_fwdEngineIcmpRoutingMsg(int8 enable);
int32 rtl8651_fwdEngineDMZHostIcmpPassThrough(int8 enable);
int32 rtl8651_fwdEngineArpProxy(int8 enable);
int32 rtl8651_fwdEngineProcessL34(int8 routingEnable);
int32 rtl8651_fwdEngineProcessIPFragment(int8 enable);
int32 rtl8651_fwdEngineProcessIPMulticast(int8 enable);
int32 rtl8651_fwdEnginePppoeNotExistedSessionTermination(int8 enable);
int32 rtl8651_fwdEngineProcessPortBouncing(int8 enable);
struct rtl_mBuf;
typedef int32 (*alg_funcptr)(struct rtl_pktHdr *pkthdr , void *ipheader, void *);
int32 rtl8651_fwdEngineInput(void * pkthdr);
void rtl8651_fwdEngineTimeUpdate(uint32 secPassed);
int32 rtl8651_fwdEngineRegisterAlgModule(uint16 ,  uint16 , 
	int32 	(*alg_init)(void *),
	alg_funcptr alg_outboundClientcb,
	alg_funcptr alg_inboundClientcb,
	alg_funcptr alg_outboundServercb,
	alg_funcptr alg_inboundServercb
); 
int32 rtl8651_fwdEngineRemoveAlgModule(uint16 ,  uint16 );
typedef struct rtl8651_tblDrvFwdEngineCounts_s {
	uint32 arpReceive, arpAddSuccess, arpAddFail, arpDelete, arpReply, arpGenerate;
	uint32 ipReceive, ipErrorReceive;
	uint32 icmpReceive, icmpErrorReceive, icmpReply, icmpReplyFailed, icmpDrop, icmpSend;
	uint32 igmpReceive, igmpErrorReceive;
	uint32 udpReceive, udpErrorReceive,udpSend;
	uint32 tcpReceive, tcpErrorReceive,tcpSend;
	uint32 l34actionLookupFailed, l34actionFailed;
	uint32 pppoeDiscoveryReceive, pppoeDiscoveryProcessed;
	uint32 pppoeSessionReceive, pppoeSessionProcessed;
	uint32 inAclDrop, inAclPermit,inAclCpu;
	uint32 outAclDrop, outAclPermit, outAclCpu;
	uint32 dmzDrop;
	uint32 natdrop, wlan2lanRelay, lan2wlanRelay;
	uint32 dosDrop;
	
} rtl8651_tblDrvFwdEngineCounts_t;
int32 rtl8651_getFwdEngineCounter(rtl8651_tblDrvFwdEngineCounts_t * counter);

void _rtl8651_l4AddSeq(struct ip *, rtl8651_tblDrv_naptTcpUdpFlowEntry_t *, int32 );
int32 _rtl8651_l4SeqDiff(uint32 , uint32 );
int32 _rtl8651_l4GetDeltaSeqOut(struct ip *, struct tcphdr *, rtl8651_tblDrv_naptTcpUdpFlowEntry_t  *);

#ifdef _RTL_UPNP
void rtl8651_addUpnpMap(uint32 ,ipaddr_t , uint16 , ipaddr_t , uint16 ,	ipaddr_t , uint16 );
void rtl8651_delUpnpMap(uint32 ,ipaddr_t , uint16 , ipaddr_t , uint16 ,	ipaddr_t , uint16 );
#endif /* _RTL_UPNP */

#ifdef _RTL_TRIGGER_PORT
void rtl8651a_flushTriggerPortRules(uint32);
int rtl8651a_addTriggerPortRule(uint32,uint8,uint16,uint16,uint8,uint16,uint16, ipaddr_t );
void rtl8651_flushTriggerPortRules(void);
int rtl8651_addTriggerPortRule(uint8,uint16,uint16,uint8,uint16,uint16, ipaddr_t );
#endif /* _RTL_TRIGGER_PORT */

void rtl8651a_setUdpSizeThreshValue(uint32 dsid, uint32 value);

/*
void rtl8651_flushProtoStackUsedUdpPorts(void);
void rtl8651_flushProtoStackServerUsedTcpPorts(void);
int32 rtl8651_addProtoStackUsedUdpPort(uint16  s_port);
int32 rtl8651_addProtoStackServerUsedTcpPort(uint16  s_port);
*/
void rtl8651_flushProtoStackActions(void);
int32 rtl8651_addProtoStackActions(ipaddr_t ip,ipaddr_t mask,uint8 action,uint8 role,uint8 protocol,uint16 orgPort,uint16 fwdPort);
void rtl8651_aliasProtoStackSentPkt(uint32 outbound, uint32 dsid, struct ip *ip);



int32  rtl8651_isdigit(int32);
int32 rtl8651_isspace(int32);
	
void rtl8651_installArpAgent(int32  (*arpAgent)(struct rtl_pktHdr *pkthdrPtr,struct rtl_mBuf *mbufPtr,uint16 vid));
void rtl8651_installAclFilter(
	int32 (*ingressAcl)(uint32 dsid,rtl8651_tblDrv_vlanTable_t *pVlan,int32 vid, uint8 *m_data, uint8 *ip),
	int32 (*egressAcl)(uint32 dsid,rtl8651_tblDrv_vlanTable_t *pVlan,int32 vid, uint8 *ethHdr, uint8 *ip)
);

int32 rtl8651_fwdEngineL2Input(struct rtl_pktHdr *pkthdrPtr,rtl8651_tblDrv_vlanTable_t *local_vlanp, uint8 *m_data, uint16 ethtype);
int32 rtl8651_fwdEngineExtPortRecv(void *id, uint8 *data,  uint32 len, uint16 myvid, uint32 myportmask, uint16 linkId);
int32 rtl8651_fwdEngineEnableWDS(int32 flag);
int32 rtl8651_fwdEngineEnableWanRouting(int8 enable);

/**************************************************************************
							Shared utility
**************************************************************************/
// define parameters passed to fwd-engine ICMP reply functions
typedef struct _rtl8651_IcmpPktField_s{
	uint8	ic_type;
	uint8	ic_code;
	union{
		uint16	next_mtu;
	} ic_hun;
	#define ic_mtu	ic_hun.next_mtu
} _rtl8651_IcmpPktField_t;
int32 _rtl8651_drvIcmpErrorGeneration(struct rtl_pktHdr *, struct ip*, _rtl8651_IcmpPktField_t *, uint16);

	
#ifdef _RTL_UPNP
struct _RTL8651_UPNP_ENTRY{
	ipaddr_t remote_ip;
	uint16 remote_port; 
	ipaddr_t alias_ip;
	uint16 alias_port;
	ipaddr_t local_ip;
	uint16 local_port;	
	
	uint32 flags;
#define UPNP_VLAID	0x01
#define UPNP_TCP 0x02
#define UPNP_ONESHOT 0x04
#define UPNP_PERSIST 0x08
	uint32 age; /* second */
};
#define UPNP_ITEM 60
#define UPNP_AGE 120

#endif /* _RTL_UPNP */

#ifdef _RTL_TRIGGER_PORT
#define TRIGGER_PORT_ITEM 64
struct _RTL8651_TRIGGER_PORT_ENTRY{
	uint32 dsid;
	ipaddr_t localIpAddr;
	uint8  inType;
	uint8  outType;
	uint16 inPortStart; 
	uint16 inPortFinish; 
	uint16 outPortStart; 
	uint16 outPortFinish;
};
#endif /* _RTL_TRIGGER_PORT */

#ifdef _RTL_PORT_BOUNCING
#define PORT_BOUNCING_ITEM 64
struct _RTL8651_PORT_BOUNCING_ENTRY{
	
	ipaddr_t clientIpAddr;
	ipaddr_t gatewayIpAddr;	
	ipaddr_t serverIpAddr;
	uint16 clientPort; 
	uint16 gatewayPort; 	
	uint16 serverPort;
	uint16 id;					// for ICMP flow: l4 id field
	uint16 flowType;
	uint32 tcpFlag;				// state for tcp flow
	uint32 age;
};
#endif

typedef struct _rtl8651_pppoeActiveSession_entry_s {
	uint16 sessionId;
	uint16 keepAlive;//When value down-count to zero, this entry becomes invalid
	struct _rtl8651_pppoeActiveSession_entry_s * next;
} _rtl8651_pppoeActiveSession_entry_t;

/*
		System initiation
*/
typedef struct rtl8651_fwdEngineInitPara_s {
	/* ip Fragment */
	uint32 MaxFragPktCnt;
	uint32 MaxFragSubPktCnt;
	uint32 MaxNegativeListEntryCnt;
	uint32 MaxPositiveListEntryCnt;
	uint32 MaxFragPoolCnt;
	uint32 MaxFragTimeOut;
	uint32 MaxNegativeListTimeOut;
	/* ip multicast */
	uint32 MaxMCastCnt;
	uint32 MaxMCastMemberCnt;
	uint32 MaxMCastTotalMemberCnt;
	uint32 MaxMCastTotalSourceCnt;
	uint32 MCastMember_ExpireTime;
	uint32 MCastUpstream_Timeout;
	uint32 MCastFilterEntryCnt;				/* Entry Count of Multicast Filter entry(for multicast group which need processed by protocol stack) */
	uint32 igmp_qi;
	uint32 igmp_qri;
	uint32 igmp_oqpi;
	uint32 igmp_sqc;
	uint32 igmp_sqi;
	uint32 igmp_lmqc;
	uint32 igmp_lmqi;
	uint32 igmp_gmi;							/* Group Member Interval */
	uint32 igmp_group_query_interval;
	uint32 igmp_response_tolerance_delay;
	/* dos */
	/* per-sip flood */
	uint32 dos_SynFlood_trackCnt;
	uint32 dos_StealthFin_trackCnt;
	uint32 dos_UdpFlood_trackCnt;
	uint32 dos_IcmpFlood_trackCnt;
	uint32 dos_total_trackCnt;
	/* port scan tracking */
	uint32 dos_total_portScan_trackCnt;
	/* dos proc : source ip blocking */
	uint32 dosProc_sipblock_count;
	/* pppoe NOT existed session termination */
	uint32 pppoeActiveSessionTrackingNumber;
	uint32 mbufHeadroom;//mbuf reserve headroom
} rtl8651_fwdEngineInitPara_t;

#define FWDENG_MBUF_HEADROOM	128  /*default headroom reserved*/
extern rtl8651_fwdEngineInitPara_t rtl8651_fwdEnginePara;
#define FWD_INIT_CHECK(expr) do {\
	if((expr)!=SUCCESS){\
		rtlglue_printf("Error >>> initialize failed at line %d!!!\n", __LINE__);\
			return FAILED;\
	}\
}while(0)



//#define RTL8651_MAX_PROTO_STACK_USED_UDP_PORTS 8
//#define RTL8651_MAX_PROTO_STACK_SERVER_USED_TCP_PORTS 8

#define	_RTL8651_ADJUST_CHECKSUM(acc, cksum) \
	do { \
		acc += ntohs(cksum); \
		if (acc < 0) { \
			acc = -acc; \
			acc = (acc >> 16) + (acc & 0xffff); \
			acc += acc >> 16; \
			cksum = htons((uint16) ~acc); \
		} else { \
			acc = (acc >> 16) + (acc & 0xffff); \
			acc += acc >> 16; \
			cksum = htons((uint16) acc); \
		} \
	} while (0)

#define _RTL8651_DATA_ADJUST_CHECKSUM(data_mod, data_org, cksum) \
        do { \
                int32 accumulate; \
                accumulate = ((data_org) - (data_mod)); \
                _RTL8651_ADJUST_CHECKSUM( accumulate, (cksum)); \
        } while(0)
	
#define _RTL8651_L4_ADJUST_CHECKSUM(ip_mod, ip_org, port_mod, port_org, cksum) \
        do { \
                int32 accumulate = 0; \
                if (((ip_mod) != 0) && ((ip_org) != 0)){ \
                        accumulate = ((ip_org) & 0xffff); \
                        accumulate += (( (ip_org) >> 16 ) & 0xffff); \
                        accumulate -= ((ip_mod) & 0xffff); \
                        accumulate -= (( (ip_mod) >> 16 ) & 0xffff); \
                } \
                if (((port_mod) != 0) && ((port_org) != 0)){ \
                        accumulate += (port_org); \
                        accumulate -= (port_mod); \
                } \
                _RTL8651_ADJUST_CHECKSUM(accumulate, (cksum)); \
        }while(0)

#define _RTL8651_L3_ADJUST_CHECKSUM(ip_mod, ip_org, cksum) \
        do {\
                _RTL8651_L4_ADJUST_CHECKSUM((ip_mod), (ip_org), 0, 0, (cksum)); \
        }while(0)
	
	
uint16  _rtl8651_ipChecksum(struct ip * pip);
uint16 _rtl8651_icmpChecksum(struct ip * pip);
uint16 _rtl8651_tcpChecksum(struct ip * pip);	

void rtl8651a_setUdpSizeThreshValue(uint32 SessionID, uint32 value);
/* gre header structure: -------------------------------------------- */

#define hton8(x)  (x)
#define ntoh8(x)  (x)
#define hton16(x) htons(x)
#define ntoh16(x) ntohs(x)
#define hton32(x) htonl(x)
#define ntoh32(x) ntohl(x)

#if 0
#define PPTP_GRE_PROTO  0x880B
#define PPTP_GRE_VER    0x1

#define PPTP_GRE_FLAG_C	0x80
#define PPTP_GRE_FLAG_R	0x40
#define PPTP_GRE_FLAG_K	0x20
#define PPTP_GRE_FLAG_S	0x10
#define PPTP_GRE_FLAG_A	0x80

#define PPTP_GRE_IS_C(f) ((f)& PPTP_GRE_FLAG_C)
#define PPTP_GRE_IS_R(f) ((f)& PPTP_GRE_FLAG_R)
#define PPTP_GRE_IS_K(f) ((f)& PPTP_GRE_FLAG_K)
#define PPTP_GRE_IS_S(f) ((f)& PPTP_GRE_FLAG_S)
#define PPTP_GRE_IS_A(f) ((f)& PPTP_GRE_FLAG_A)
#endif

struct wan_gre_header {
  uint8 flags;			/* bitfield */
  uint8 ver;			/* should be PPTP_GRE_VER (enhanced GRE) */
  uint16 protocol;		/* should be PPTP_GRE_PROTO (ppp-encaps) */
  uint16 payload_len;	/* size of ppp payload, not inc. gre header */
  uint16 call_id;		/* peer's call_id for this session */
  uint32 seq;			/* sequence number.  Present if S==1 */
  uint32 ack;			/* seq number of highest packet recieved by */
  						/*  sender in this session */
};


struct wan_l2tp_header {

  uint16 flags_type:1;
  uint16 flags_length:1;
  uint16 flags_rsv1:2;
  uint16 flags_sequence:1;
  uint16 flags_rsv2:1;
  uint16 flags_offset:1;
  uint16 flags_priority:1;  
  uint16 flags_rsv3:4;  
  uint16 flags_version:4;
  
  uint16 length;
  uint16 tunnel_id;
  uint16 session_id;  
};

//for ACK Scan, SYN Scan, FIN Scan
#define PORT_SCAN_WAIT_RST 2
struct portScanInfo {
	ipaddr_t sip;
	ipaddr_t dip;
	uint32 dsid;
	uint16 sport;
	uint16 dport;
	uint8 flags;
	uint8 age; 
};

#if 0
struct _RTL8651_PPTP_SHARE_DATA {
		uint32 seq;
		uint32 ack; 
		uint32 seq_recv;	
		uint32 seq_sent;
		uint32 ack_sent;
		uint32 ack_recv;
		
		uint32 tunnel_dst_ip;
		uint32 tunnel_src_ip;
		
		uint16 pptp_gre_call_id;
		uint16 pptp_gre_peer_call_id;
		
		uint8 reserv[128];
};
#endif

extern int8 rtl8651_drvMulticastProcessEnable;
extern int8 rtl8651_drvPacketFastSend;

#endif /* RTL8651_FWDENGINE_H */
